<?php
 /**
 * @file
 * Contains \Drupal\otp_verification\Controller\DefaultController.
 */

namespace Drupal\otp_verification\Controller;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Component\Utility;
use Drupal\otp_verification\MiniorangeOtpUtilities;
use Drupal\user\Entity\User;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\Component\Utility\Unicode;
use Drupal\otp_verification\MiniorangeOtpVerificationConstants;


class otp_verificationController extends ControllerBase {
    /**
    * Validate user function.
    */
    function miniorange_otp_validate_user() {
        global $user;
        global $form;
        global $form_state;
        $form_state['uid'] = $user->uid;
        $form = self::miniorange_otp_build_form($form, $form_state);
        return $form;
    }
    public function miniorange_otp_feedback_func()
    {
        $res = '';
        $res = json_encode($_POST);
        $outarr = json_decode($res, TRUE);
        $_SESSION['mo_other'] = "False";
        $reason = $outarr['reason'];
        $q_feedback = $outarr['q_feedback'];
        $message = 'Reason: ' . $reason . '<br>Feedback: ' . $q_feedback;
        $url = 'https://login.xecurify.com/moas/api/notify/send';
        $ch = curl_init($url);
        $email = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_admin_email');
        if ( empty( $email ) ) {
            $email = $outarr['email'];
        }
        if ( \Drupal::service('email.validator')->isValid( $email ) ) {
            $phone = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_admin_phone');
            $customerKey = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_id');
            $apikey = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_api_key');
            if ( $customerKey == '' ) {
                $customerKey = "16555";
                $apikey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
            }
            $currentTimeInMillis = round(microtime(TRUE) * 1000);
            $stringToHash = $customerKey . $currentTimeInMillis . $apikey;
            $hashValue = hash("sha512", $stringToHash);
            $customerKeyHeader = "Customer-Key: " . $customerKey;
            $timestampHeader = "Timestamp: " . $currentTimeInMillis;
            $authorizationHeader = "Authorization: " . $hashValue;
            $fromEmail = $email;
            $subject = "Drupal 8 OTP Module Feedback";
            $query = '[Drupal 8 OTP]: ' . $message;
            $content = '<div >Hello, <br><br>Company :<a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>Phone Number :' . $phone . '<br><br>Email :<a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>Query :' . $query . '</div>';
            $fields = array(
                'customerKey' => $customerKey,
                'sendEmail' => true,
                'email' => array(
                    'customerKey' => $customerKey,
                    'fromEmail' => $fromEmail,
                    'fromName' => 'miniOrange',
                    'toEmail' => 'drupalsupport@xecurify.com',
                    'toName' => 'drupalsupport@xecurify.com',
                    'subject' => $subject,
                    'content' => $content
                ),
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_AUTOREFERER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);    # required for https urls
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customerKeyHeader,
                $timestampHeader, $authorizationHeader));
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
            $content = curl_exec($ch);
            if (curl_errno($ch)) {
                return json_encode(array("status" => 'ERROR', 'statusMessage' => curl_error($ch)));
            }
            curl_close($ch);
        }
        \Drupal::service('module_installer')->uninstall(['otp_verification']);
        return new Response();
    }
    /**
    * Custom form build.
    */
    function miniorange_otp_build_form($form, &$form_state, $success_form = TRUE) {
        $submit_attributes = array();
        $form =  self::miniorange_otp_build_form_content($form, $form_state, $success_form);
        $form['loader']['#markup'] = '</div><div class="mo_otp-modal-mo_otp_container mo_otp-modal-footer">';

        $form['actions']['submit'] = array(
            '#type' => 'submit',
            '#value' => 'Validate',
            '#submit' => array('::miniorange_otp_validation_user_validate'),
        );

        $form['actions']['resend'] = array(
            '#type' => 'submit',
            '#value' => t('Resend OTP'),
            '#attributes' => $submit_attributes,
            '#submit' => array('::miniorange_otp_resend_otp'),
        );

        return $form;
    }

    function miniorange_otp_verification_submit($form, &$form_state) {
        self::miniorange_otp_validation_user_validate($form, $form_state);
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

    }
    /**
    * Custom form content.
    */
    function miniorange_otp_build_form_content($form, $form_state, $success_form = TRUE) {
        return  self::miniorange_otp_build_otp_validation_form($form, $form_state, $success_form);
    }

    /**
    * Custom form build with error message.
    */
    function miniorange_otp_build_form_with_error_message(&$form_state) {
        $form = array();
        $form =  self::miniorange_otp_build_form($form, $form_state, FALSE);
        $form_state['complete form']['header']['#markup'] = $form['header']['#markup'];
        return $form;
    }

    /**
    * Custom validation form build.
    */
    function miniorange_otp_build_otp_validation_form($form, &$form_state, $success_message = TRUE) {
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        if ($otp_options == 0) {
            $form['otp'] = array(
                '#name' => 'otp',
                '#type' => 'textfield',
	            '#attributes' => array('autofocus' => 'autofocus',),
                '#title' => t('OTP'),
                '#default_value' => '',
                '#size' => 60,
                '#description' => t('Please enter the OTP that has been sent to the registered Email ID.'),
                '#maxlength' => 15,
                '#required'=>true,
            );
            return $form;
        }
        elseif ($otp_options == 1) {
            $form['otp'] = array(
                '#name' => 'otp',
                '#type' => 'textfield',
	            '#attributes' => array('autofocus' => 'autofocus',),
                '#title' => t('OTP'),
                '#default_value' => '',
                '#size' => 60,
                '#description' => t('Please enter the OTP that has been sent to the registered Phone.'),
                '#maxlength' => 15,
                '#required'=>true,
            );
            return $form;
        }
    }

    /**
    * Custom user validation.
    **/
    public function miniorange_otp_validation_user_validate($form, &$form_state) {
        $uname = $_SESSION['miniorange_otp']['register_values']['name'];
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        $mail = $_SESSION['miniorange_otp']['register_values']['mail'];
        $pwd = isset($_SESSION['miniorange_otp']['register_values']['pass'])? $_SESSION['miniorange_otp']['register_values']['pass'] : '' ;
        $otp_token = $form_state->getValue('otp');
        $trans_id = \Drupal::config('otp_verification.settings')->get('miniorange_otp_tx_id');

        if (!MiniorangeOtpUtilities::isCurlInstalled()) {
            return json_encode(array(
                "status" => 'CURL_ERROR',
                "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
            ));
        }

        $url = 'https://login.xecurify.com/moas/api/auth/validate';
        $ch = curl_init($url);
        $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_id');
        $api_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_api_key');
        $current_time_in_millis = round(microtime(TRUE) * 1000);
        $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
        $hash_value = hash("sha512", $string_to_hash);
        $customer_key_header = "Customer-Key: " . $customer_key;
        $timestamp_header = "Timestamp: " . $current_time_in_millis;
        $authorization_header = "Authorization: " . $hash_value;
        if ($otp_options == 1) {
            $fields = array(
                'txId' => $trans_id,
                'token' => $otp_token,
                'customerKey' => $customer_key,
                'username' => $mail,
                'authType' => 'PHONE',
            );
        }
        else {
            $fields = array(
                'txId' => $trans_id,
                'token' => $otp_token,
                'customerKey' => $customer_key,
                'username' => $mail,
                'authType' => 'EMAIL',
            );
        }

        $field_string = json_encode($fields);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customer_key_header, $timestamp_header, $authorization_header,));
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
        $content = curl_exec($ch);
        curl_close($ch);
      \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_token',$otp_token)->save();
       $otp_status = json_decode($content)->status;

        if ($otp_status == "SUCCESS") {
            $arr1 = \Drupal::config('otp_verification.settings')->get('arr1');
            $arr2 = \Drupal::config('otp_verification.settings')->get('arr2');
			unset($_SESSION['miniorange_otp']);
			user_register_submit($arr1,$arr2);
			//drupal_goto('<front>');

          $response = new RedirectResponse('<front>');
          $response->send();
        }
        elseif ($otp_status == "FAILED") {
          \Drupal::messenger()->addMessage(t('OTP entered is incorrect'), 'error');
        }
    }

/**
    * Resend otp.
    */
    function miniorange_otp_resend_otp(&$form, $form_state) {
        global $_miniorange_otp_x;
        $umail = $_SESSION['miniorange_otp']['register_values']['mail'];
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        \Drupal::configFactory()->getEditable('otp_verification.settings')->clear('miniorange_otp_tx_id')->save();
        if ($otp_options == 0) {
            $emailcount = mb_strlen($umail);
            $emailc1 = mb_substr($umail, 0, 3);
            $emailc2 = mb_substr($umail, $emailcount - 4, $emailcount);
            for ($i = 4; $i <= $emailcount - 4; $i++) {
                $_miniorange_otp_x = "X" . $_miniorange_otp_x;
            }
            $email_code = $emailc1 . $_miniorange_otp_x . $emailc2;
            if (!MiniorangeOtpUtilities::isCurlInstalled()) {
                return json_encode(array(
                    "status" => 'CURL_ERROR',
                    "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
                ));
            }
            $url = 'https://login.xecurify.com/moas/api/auth/challenge';
            $ch = curl_init($url);
            $api_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_api_key');
            $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_id');

            // Current time in milliseconds since midnight, January 1, 1970 UTC.
            $current_time_in_millis = round(microtime(TRUE) * 1000);

            // Creating the Hash using SHA-512 algorithm.
            $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
            $hash_value = hash("sha512", $string_to_hash);
            $customer_key_header = "Customer-Key: " . $customer_key;
            $timestamp_header = "Timestamp: " . $current_time_in_millis;
            $authorization_header = "Authorization: " . $hash_value;
            $fields = array(
                'customerKey' => $customer_key,
                'email' => $umail,
                'authType' => 'EMAIL',
                'transactionName' => 'Drupal OTP Verification',
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                "Content-Type: application/json",
                $customer_key_header,
                $timestamp_header,
                $authorization_header,
            ));

            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
            $content = curl_exec($ch);
            $trans_status = json_decode($content)->status;
            curl_close($ch);

            if ($trans_status == "SUCCESS") {
                $tx_id = json_decode($content)->txId;
                \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_tx_id',$tx_id)->save();
                \Drupal::configFactory()->getEditable('miniorange_otp_current_status.settings')->set('miniorange_otp_verification_code','OTP_SENT')->save();

              \Drupal::messenger()->addMessage(t('OTP has been resent to @otp_resend', array('@otp_resend' => $email_code)));
            }
            else {
              \Drupal::messenger()->addMessage(t('OTP could not be sent'), 'error');
            }
        }
        else {
            $ph = $_SESSION['miniorange_otp']['register_values']['phone'];
            $phno = mb_strlen($ph);
            $phbr1 = mb_substr($ph, 0, 4);
            $phbr2 = mb_substr($ph, $phno - 2, $phno);
            for ($i = 5; $i <= $phno - 2; $i++) {
                $_miniorange_otp_x = "X" . $_miniorange_otp_x;
            }
            $ph_code = $phbr1 . $_miniorange_otp_x . $phbr2;
            if (!MiniorangeOtpUtilities::isCurlInstalled()) {
                return json_encode(array(
                    "status" => 'CURL_ERROR',
                    "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
                ));
            }
            $url = 'https://login.xecurify.com/moas/api/auth/challenge';
            $ch = curl_init($url);
            $api_key =\Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_api_key');
            $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_customer_id');
            // Current time in milliseconds since midnight, January 1, 1970 UTC.
            $current_time_in_millis = round(microtime(TRUE) * 1000);
            // Creating the Hash using SHA-512 algorithm.
            $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
            $hash_value = hash("sha512", $string_to_hash);
            $customer_key_header = "Customer-Key: " . $customer_key;
            $timestamp_header = "Timestamp: " . $current_time_in_millis;
            $authorization_header = "Authorization: " . $hash_value;

            $fields = array(
              'customerKey' => $customer_key,
              'phone' => $ph,
              'authType' => 'SMS',
              'transactionName' => 'Drupal OTP Verification',
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customer_key_header, $timestamp_header, $authorization_header,));
            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);

            $content = curl_exec($ch);
            $trans_status = json_decode($content)->status;
            curl_close($ch);
            if ($trans_status == "SUCCESS") {
                $tx_id = json_decode($content)->txId;
                \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_tx_id',$tx_id)->save();
                \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_current_status','OTP_SENT')->save();

              \Drupal::messenger()->addMessage(t('OTP has been resent to @otp_resend_phone', array('@otp_resend_phone' => $ph_code)));
            }
            else {
              \Drupal::messenger()->addMessage(t('OTP could not be sent'), 'error');
            }
        }
    }

}
